#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* lab program. Try to get ranges of numbers specified 'the nmap way' */
unsigned short **get_range(char *str)
{
	int i, foo;
	unsigned int part = 0;
	int parts = 1, range, ranges = 0, entries = 0;
	unsigned short **pr, **ret_pr, lo = 0, hi = 0;

	/* bogus string? */
	if(!str || !strlen(str)) return(NULL);

	/* nopes count it (break at dot delimiter) ... */
	for(i=0; i<(int)strlen(str)-1; i++) {
		if(str[i] == ',') parts++;
		if(str[i] == '.') break;
	}

	/* ... malloc (1 extra for easy iteration later) ... */
	pr = (unsigned short **)malloc(sizeof(short *) * (parts + 1));
	ret_pr = (unsigned short **)malloc(sizeof(short *) * (parts + 1));
	for(i=0; i<parts; i++) {
		pr[i] = (short *)malloc(sizeof(short) * 2);
		ret_pr[i] = (short *)malloc(sizeof(short) * 2);
		memset(pr[i], 0, sizeof(short) * 2);
		memset(ret_pr[i], 0, sizeof(short) * 2);
	}

	/* ... and parse */

	/* get the first part of it */
	part = 0;
	pr[part][0] = strtoul(str, NULL, 0);
	/* iterate the rest */
	for(i=0; i<(int)strlen(str)-1; i++) {
		if(str[i] == '.') break;
		if(str[i] == ',' || str[i] == '-') {
			if(str[i] == ',') {
				pr[++part][0] = strtoul(&str[i+1], NULL, 0);
			}
			else if(str[i] == '-') {
				ranges++;
				pr[part][1] = strtoul(&str[i+1], NULL, 0);
				/* fix 'reverse' ranges */
				if(pr[part][1] <= pr[part][0]) {
					foo = (int)pr[part][1];
					pr[part][1] = pr[part][0];
					pr[part][0] = (unsigned short)foo;
				}
			}
		}
	}

	/* if only one range or a single port, we simply return it */
	if(parts == 1) {
		free(ret_pr);
		return(pr);
	}

	/* make each entry unique (harder than it seems) */
	while(1) {
		range = -1;
		/* find first real range */
		for(foo=0; foo<parts; foo++) {
			if(pr[foo][0] == pr[foo][1]) pr[foo][1] = 0;
			if(!pr[foo][1]) continue;
			lo = pr[foo][0];
			hi = pr[foo][1];
			/* reset the original values */
			range = foo;
			pr[foo][0] = pr[foo][1] = 0;
			break;
		}

		if(range == -1) break;

		/* we have a starting range, so we expand it if need be,
		 * zeroing our trails as we go along */
		for(i=0; i<parts; i++) {
			/* single ports are dealt with later, so we can skip all
			 * non-matching */
			if(pr[i][0] > hi || pr[i][1] < lo) continue;

			/* new range completely within current */
			if(pr[i][0] >= lo && pr[i][1] <= hi) {
				pr[i][0] = pr[i][1] = 0;
				continue;
			}

			if(pr[i][0] <= lo-1) {
				lo = pr[i][0];
				if(pr[i][1] >= hi+1) {
					hi = pr[i][1];
				}
				pr[i][0] = pr[i][1] = 0;
			}

			if(pr[i][1] >= hi+1) {
				hi = pr[i][1];
				pr[i][0] = pr[i][1] = 0;
			}
		}
		ret_pr[entries][0] = lo;
		ret_pr[entries++][1] = hi;
	}

	for(i=0; i<parts; i++) {
		if(!pr[i][0]) continue;

		if(entries == parts) break;

		/* check if this single port is part of any range */
		for(foo=0; foo<entries; foo++) {
			if(ret_pr[foo][0] <= pr[i][0] && pr[i][0] <= ret_pr[foo][1]) {
				pr[i][0] = 0;
				break;
			}
		}
		/* if it still has a value, we add it */
		if(pr[i][0]) ret_pr[entries++][0] = pr[i][0];
	}


	/* let's be prudent and not waste memory */
	free(pr);
	pr = (unsigned short **)malloc(sizeof(short *) * (entries + 1));

	for(i=0; i<entries; i++) {
		pr[i] = (unsigned short *)malloc(sizeof(short) * 2);
		pr[i][0] = ret_pr[i][0];
		pr[i][1] = ret_pr[i][1];
	}

	free(ret_pr);
	return (pr);
}


/*** main ***/
int main(int argc, char **argv)
{
	int i, n;
	unsigned short **nr;

	if(argc < 2) {
		printf("Args, you git!\n");
		exit(-1);
	}

	for(i=1; i<argc; i++) {
		nr = get_range(argv[i]);

		n = -1;
		if(nr) while(nr[++n]) {
			printf("-> nr[%d] = {%d, %d};\n", n, nr[n][0], nr[n][1]);
		}
	}
	return (0);
}
